<?php
/**
* @package WP-Speech-Balloon_bundle
* @version 2.4
*/
/*
Plugin Name: WP-Speech-Balloon (bundle)
Plugin URI: https://tips4life.me/wp-speech-balloon_2_4
Description: Wordpressで簡単に吹き出し会話を使えるプラグインです。1.xからお使いの方で過去記事の修正が不可な方はこちらをお使い下さい。
Version: 2.4
Author: RA’s
Author URI: https://tips4life.me/profile
License: GPLv2
*/
wp_enqueue_style('wsb_bdl', plugins_url('css/style.css', __FILE__));

//AMP
function is_wsb_amp(){
	$is_wsb_amp = false;
	if ( empty($_GET['amp']) ) {
		return false;
	}
	if($_GET['amp'] === '1') {
		$is_wsb_amp = true;
	}
	return $is_wsb_amp;
}

function wsb_bdl_callBack($wsb_bdl_buffer) {
	if(is_wsb_amp() && strpos($wsb_bdl_buffer, '<div class="wsb"') !== false){
		$wsb_bdl_css = file_get_contents(plugin_dir_url( __FILE__ ).'css/style.php');
		$aryPtrns = array('wsb-l ', 'wsb-l1 ', 'wsb-l2 ', 'wsb-l3 ', 'wsb-l4 ', 'wsb-l5 ', 'wsb-r ', 'wsb-r1 ', 'wsb-r2 ', 'wsb-r3 ', 'wsb-r4 ', 'wsb-r5 ',
						'wsb-l1-gray ', 'wsb-l2-gray ', 'wsb-l3-gray ', 'wsb-r1-gray ', 'wsb-r2-gray ', 'wsb-r3-gray ');
		foreach ($aryPtrns as $aryPtrn) {
			if(strpos($wsb_bdl_buffer, $aryPtrn) === false){
				$wsb_bdl_css = preg_replace('/\.'.preg_quote($aryPtrn, '/').'.*?\}/i', "", $wsb_bdl_css);
			}
		}
		$wsb_bdl_buffer = str_replace('<style amp-custom>', '<style amp-custom>'.$wsb_bdl_css, $wsb_bdl_buffer);
	}
	return $wsb_bdl_buffer;
}
function wsb_bdl_bufStart() { ob_start("wsb_bdl_callBack"); }
function wsb_bdl_bufEnd() { ob_end_flush(); }
add_action('after_setup_theme', 'wsb_bdl_bufStart');
add_action('shutdown', 'wsb_bdl_bufEnd');

function sc_bal_L1(){ return '<div class="bal-l"><div class="avaBox"><img src="';}
function sc_bal_L2(){ return '" width="60" height="60" alt="avatar"></div><div class="txtBox">';}
function sc_bal_L3(){ return '</div></div>';}
function sc_bal_R1(){ return '<div class="bal-r"><div class="txtBox">';}
function sc_bal_R2(){ return '</div><div class="avaBox"><img src="';}
function sc_bal_R3(){ return '" width="60" height="60" alt="avatar"></div></div>';}
function sc_bal2_L1(){ return '<div class="bal-l2"><div class="avaBox"><img src="';}
function sc_bal2_R1(){ return '<div class="bal-r2"><div class="txtBox">';}
add_shortcode('bal_L1','sc_bal_L1');
add_shortcode('bal_L2','sc_bal_L2');
add_shortcode('bal_L3','sc_bal_L3');
add_shortcode('bal_R1','sc_bal_R1');
add_shortcode('bal_R2','sc_bal_R2');
add_shortcode('bal_R3','sc_bal_R3');
add_shortcode('bal2_L1','sc_bal2_L1');
add_shortcode('bal2_R1','sc_bal2_R1');

//L1_wsbStart - default -
function sc_L1_wsbStart(){ return '<div class="wsb"><div class="wsb-l wsb-l1 ">';}
add_shortcode('L1_wsbStart','sc_L1_wsbStart');

//L1_gray_wsbStart - default gray -
function sc_L1_gray_wsbStart(){ return '<div class="wsb"><div class="wsb-l wsb-l1-gray ">';}
add_shortcode('L1_gray_wsbStart','sc_L1_gray_wsbStart');

//L2_wsbStart - thinking -
function sc_L2_wsbStart(){ return '<div class="wsb"><div class="wsb-l wsb-l2 ">';}
add_shortcode('L2_wsbStart','sc_L2_wsbStart');

//L2_gray_wsbStart - thinking gray -
function sc_L2_gray_wsbStart(){ return '<div class="wsb"><div class="wsb-l wsb-l2-gray ">';}
add_shortcode('L2_gray_wsbStart','sc_L2_gray_wsbStart');

//L3_wsbStart - pastel -
function sc_L3_wsbStart(){ return '<div class="wsb"><div class="wsb-l wsb-l3 ">';}
add_shortcode('L3_wsbStart','sc_L3_wsbStart');

//L3_gray_wsbStart - pastel gray -
function sc_L3_gray_wsbStart(){ return '<div class="wsb"><div class="wsb-l wsb-l3-gray ">';}
add_shortcode('L3_gray_wsbStart','sc_L3_gray_wsbStart');

//L4_wsbStart - lineStyle -
function sc_L4_wsbStart(){ return '<div class="wsb"><div class="wsb-l wsb-l4 ">';}
add_shortcode('L4_wsbStart','sc_L4_wsbStart');

//L5_wsbStart - twStyle -
function sc_L5_wsbStart(){ return '<div class="wsb"><div class="wsb-l wsb-l5 ">';}
add_shortcode('L5_wsbStart','sc_L5_wsbStart');

//L_wsbAvatar
function sc_L_wsbAvatar(){ return '<div class="avaArea"><p class="avaImg"><img src="';}
add_shortcode('L_wsbAvatar','sc_L_wsbAvatar');

//L_wsbName
function sc_L_wsbName(){ return '" width="70" height="70" alt="avatar"></p><p class="avaName">';}
add_shortcode('L_wsbName','sc_L_wsbName');

//L_wsbText
function sc_L_wsbText(){ return '</p></div><div class="txtArea"><p class="wsbTxt">';}
add_shortcode('L_wsbText','sc_L_wsbText');

//L_wsbEnd
function sc_L_wsbEnd(){ return '</p></div></div></div>';}
add_shortcode('L_wsbEnd','sc_L_wsbEnd');

//R1_wsbStart - default -
function sc_R1_wsbStart(){ return '<div class="wsb"><div class="wsb-r wsb-r1 ">';}
add_shortcode('R1_wsbStart','sc_R1_wsbStart');

//R1_gray_wsbStart - default gray -
function sc_R1_gray_wsbStart(){ return '<div class="wsb"><div class="wsb-r wsb-r1-gray ">';}
add_shortcode('R1_gray_wsbStart','sc_R1_gray_wsbStart');

//R2_wsbStart - powapowa -
function sc_R2_wsbStart(){ return '<div class="wsb"><div class="wsb-r wsb-r2 ">';}
add_shortcode('R2_wsbStart','sc_R2_wsbStart');

//R2_gray_wsbStart - powapowa gray -
function sc_R2_gray_wsbStart(){ return '<div class="wsb"><div class="wsb-r wsb-r2-gray ">';}
add_shortcode('R2_gray_wsbStart','sc_R2_gray_wsbStart');

//R3_wsbStart - pastel -
function sc_R3_wsbStart(){ return '<div class="wsb"><div class="wsb-r wsb-r3 ">';}
add_shortcode('R3_wsbStart','sc_R3_wsbStart');

//R3_gray_wsbStart - pastel gray -
function sc_R3_gray_wsbStart(){ return '<div class="wsb"><div class="wsb-r wsb-r3-gray ">';}
add_shortcode('R3_gray_wsbStart','sc_R3_gray_wsbStart');

//R4_wsbStart - lineStyle -
function sc_R4_wsbStart(){ return '<div class="wsb"><div class="wsb-r wsb-r4 ">';}
add_shortcode('R4_wsbStart','sc_R4_wsbStart');

//R5_wsbStart - twStyle -
function sc_R5_wsbStart(){ return '<div class="wsb"><div class="wsb-r wsb-r5 ">';}
add_shortcode('R5_wsbStart','sc_R5_wsbStart');

//R_wsbText
function sc_R_wsbText(){ return '<div class="txtArea"><p class="wsbTxt">';}
add_shortcode('R_wsbText','sc_R_wsbText');

//R_wsbAvatar
function sc_R_wsbAvatar(){ return '</p></div><div class="avaArea"><p class="avaImg"><img src="';}
add_shortcode('R_wsbAvatar','sc_R_wsbAvatar');

//R_wsbName
function sc_R_wsbName(){ return '" width="70" height="70" alt="avatar"></p><p class="avaName">';}
add_shortcode('R_wsbName','sc_R_wsbName');

//R_wsbEnd
function sc_R_wsbEnd(){ return '</p></div></div></div>';}
add_shortcode('R_wsbEnd','sc_R_wsbEnd');

//wsb_bdl_auto_formatting_fix
function wsb_bdl_auto_formatting_fix($content) {
	$array = array (
		'<p>[L1_wsbStart]' => '[L1_wsbStart]',
		'<p>[L2_wsbStart]' => '[L2_wsbStart]',
		'<p>[L3_wsbStart]' => '[L3_wsbStart]',
		'<p>[L4_wsbStart]' => '[L4_wsbStart]',
		'<p>[L5_wsbStart]' => '[L5_wsbStart]',
		'<p>[R1_wsbStart]' => '[R1_wsbStart]',
		'<p>[R2_wsbStart]' => '[R2_wsbStart]',
		'<p>[R3_wsbStart]' => '[R3_wsbStart]',
		'<p>[R4_wsbStart]' => '[R4_wsbStart]',
		'<p>[R5_wsbStart]' => '[R5_wsbStart]',
		'[L_wsbText]</p>'."\n".'<p>' => '[L_wsbText]',
		'[R_wsbText]</p>'."\n".'<p>' => '[R_wsbText]',
		'[L_wsbEnd]</p>'   => '[L_wsbEnd]',
		'[R_wsbEnd]</p>'   => '[L_wsbEnd]',
		'[L_wsbEnd]<br />' => '[L_wsbEnd]',
		'[R_wsbEnd]<br />' => '[L_wsbEnd]'
	);
	$content = strtr($content, $array);
	return $content;
}
add_filter('the_content', 'wsb_bdl_auto_formatting_fix');
